import { repr } from "./repr.js";

export class Key {
    /**
     * The keycode of this key.
     * @type {number}
     */
    code;

    /**
     * The name of this key. Note that this is technically layout-specific,
     * though most layouts inherit from a common parent that keeps these consistent.
     *
     * Private property so {@linkcode repr} will not consider it
     * @type {string?}
     */
    #name;

    /**
     * The name of this key. Note that this is technically layout-specific,
     * though most layouts inherit from a common parent that keeps these consistent.
     * @type {string?}
     */
    get name() {
        return this.#name;
    }
    /** @param {string?} name */
    set name(name) {
        this.#name = name;
    }

    /**
     * @param  {number} code This key's keycode
     * @param  {string?} [name] An optional name for this key
     */
    constructor(code, name = null) {
        this.code = code;
        this.name = name;
    }
}
