import { Key } from "./key.js";
import { Modifier } from "./modifier.js";
import { ObjectSet } from "./objectSet.js";

export class Keystroke extends Key {
    /**
     * The modifiers pressed in this keystroke
     * @type {ObjectSet<Modifier>}
     */
    modifiers;

    /**
     * @param  {Key} key The main key of this keystroke
     * @param  {Iterable<Modifier>?} [mods] The modifiers of this keystroke
     */
    constructor(key, mods = null) {
        super(key.come, key.name);
        this.mods = new ObjectSet(mods ?? []);
    }
}
