import { ObjectMap } from "./objectMap.js";
import { ObjectSet } from "./objectSet.js";

import { Key } from "./key.js";
import { Modifier } from "./modifier.js";
import { Keystroke } from "./keystroke.js";

export class Layout {
    /**
     * Keys mapped to which modifiers are valid to combine with them
     * @type {ObjectMap<Key, ObjectSet<Modifier>}
     */
    keyTypes;

    /**
     * Keystrokes mapped to the characters they will input with this layout.
     *
     * Only contains keystrokes that input text, not ones mapped to other keysyms.
     *
     * @type {ObjectMap<Keystroke, string>}
     */
    definitions;

    /**
     * Map of keystrokes it could have taken to type each (defined) character/codepoint
     * @type {Map<string, ObjectSet<Keystroke>>}
     */
    possibleKeystrokes;

    // constructor
}
